C Test program for the subroutine MAP_STEEL_COOLCU
C
C
      DOUBLE PRECISION VOLT,CURR,EFF,SPEED,TINT,C1,C2
      DOUBLE PRECISION CTEMP(16),TIME(16),TIM
      INTEGER IFAIL,L1
C
      WRITE (*,*) 'Welding voltage and welding current:'
      READ(*,*) VOLT, CURR
      WRITE (*,*) 'Welding speed and welding efficiency:'
      READ (*,*) SPEED, EFF
      WRITE (*,*) 'Interpass temperature:'
      READ(*,*) TINT
      WRITE (*,*) 'C1 and C2:'
      READ(*,*) C1, C2
      CALL MAP_STEEL_COOLCU(VOLT, CURR, EFF, SPEED, TINT,
     &     C1, C2, CTEMP, TIME, TIM, IFAIL)
      IF (IFAIL .EQ. 1) THEN
         WRITE (6,1) 
      ELSE 
         WRITE (6,2) 
         DO 100 L1=1,16
            WRITE (6,3) CTEMP(L1), TIME(L1)
  100    CONTINUE
         WRITE (6,4) TIM
      ENDIF
      STOP
    1 FORMAT ('Interpass temperature is too high')
    2 FORMAT ('Temperature (deg. C)  Time (seconds)')
    3 FORMAT (5X,F8.2,11X,F8.2)
    4 FORMAT (/'Time to cool from 800C to 500C =',F8.2,' seconds')
      END

C Copyright Dr. H. K. D. H. Bhadeshia, University of Cambridge
C June 1990
C Program to calculate THE COOLING CURVE
C April 1988
C
      SUBROUTINE MAP_STEEL_COOLCU(VOLT,CURR,EFF,SPEED,TINT,C1,C2,
     &           CTEMP,TIME,TIM,IFAIL)
      IMPLICIT NONE                           
      DOUBLE PRECISION CTEMP(16),TIME(16)
      DOUBLE PRECISION C1,C2,CURR,EFF,SPEED,THIGH,TIM,TINT,TLOW,VOLT
      INTEGER I,IFAIL
      IFAIL = 0
      THIGH=1000.0D0
C
C EFF is the arc transfer efficiency
C C1 and C2 are heat flow constants, Scand. J . Metall. eq.1c
C
      IF(TINT .GT. 499.0) GOTO 100   
      GOTO 110
  100 IFAIL = 1  
      GOTO 150
  110 DO 140 I=1,16
         CTEMP(I) = THIGH-I*50.0
         TLOW = CTEMP(I)
         IF (TLOW .LE. TINT) GOTO 120
         GOTO 130
  120    CTEMP(I)=TINT+1.0
         TLOW=TINT+1.0
  130    TIME(I)=((CURR*VOLT/SPEED)*EFF/(C1*(1.0D+00-C2)))*
     &     ((THIGH-TINT)**(1.0-C2)-(TLOW-TINT)**(1.0-C2))
  140 CONTINUE
      TIM=TIME(10)-TIME(4)
  150 RETURN
      END
